#include <math.h>
#include "3d.h"
 
//  }gNX̐ݒ
static void setMatrix( double matrix[][4],
                double mat00,   double mat01,   double mat02,   double mat03,
                double mat10,   double mat11,   double mat12,   double mat13,
                double mat20,   double mat21,   double mat22,   double mat23,
                double mat30,   double mat31,   double mat32,   double mat33 )
{
    matrix[0][0]=mat00; matrix[0][1]=mat01; matrix[0][2]=mat02; matrix[0][3]=mat03;
    matrix[1][0]=mat10; matrix[1][1]=mat11; matrix[1][2]=mat12; matrix[1][3]=mat13;
    matrix[2][0]=mat20; matrix[2][1]=mat21; matrix[2][2]=mat22; matrix[2][3]=mat23;
    matrix[3][0]=mat30; matrix[3][1]=mat31; matrix[3][2]=mat32; matrix[3][3]=mat33;
}
 
//  }gbNXE|CgvZ
static void calcMatrixPoint( double matrix[][4],double out[],double in[])
{
    int  i,j;
    //  s̉ZB
    for( i=0 ; i<4; i++ ) {
        out[i] = 0;
        for( j=0 ; j<4; j++ ) {
            out[i] += in[j] * matrix[j][i];
        }
    }
}
 
//  Rs[}gbNX
static void copyMatrix( double dstMat[][4],double srcMat[][4])
{
    int  i,j;
    //  Rs[
    for( i=0 ; i<4; i++ ) {
        for( j=0 ; j<4; j++ ) {
            dstMat[i][j] = srcMat[i][j];
        }
    }
}
 
//  }gbNXvZ
static void calcMatrix( double dstMat[][4],double srcMat[][4])
{
    int  i,j,k;
    double matrix[4][4];
    
    //  NA
    for( i=0 ; i<4; i++ ) {
        for( j=0 ; j<4; j++ ) {
            matrix[i][j] = 0;
        }
    }
    //  s̉ZB
    for( i=0 ; i<4; i++ ) {
        for( j=0 ; j<4; j++ ) {
            for( k=0 ; k<4; k++ ) {
                matrix[i][j] += dstMat[i][k] * srcMat[k][j];
            }
        }
    }
    //  Rs[
    copyMatrix(dstMat,matrix);
}
 
int henkan3dzahyou(double* ox,double* oy,
        double x,double y,double z,const camera_t* camera)
{
    double Mmatrix[4][4];//ړϊs
    double Pmatrix[4][4];//ˉeϊs
    double point3D[4];  //ϊOW
    double Mpoint3D[4]; //ړϊW
    double Ppoint3D[4]; //ˉeϊW
    int i,j;
    
    //  RcWlݒ肷B
    point3D[0] = x;
    point3D[1] = y;
    point3D[2] = z;
    point3D[3] = 1;
    
    //  Jr[ϊB
    {
        double RXmatrix[4][4];//X]s
        double RYmatrix[4][4];//Y]s
        double RZmatrix[4][4];//Z]s
        double MVmatrix[4][4];//sړs
        double rot;
        
        //  Pʃ}gbNXݒ
        setMatrix( Mmatrix,
                    1,          0,          0,          0,
                    0,          1,          0,          0,
                    0,          0,          1,          0,
                    0,          0,          0,          1   );
        //  X]}gbNX
        rot = -camera->cx;
        setMatrix( RXmatrix,
                    1,          0,          0,          0,
                    0,          cos(rot),   sin(rot),   0,
                    0,          -sin(rot),  cos(rot),   0,
                    0,          0,          0,          1   );
        //  Y]}gbNX
        rot = -camera->cy;
        setMatrix( RYmatrix,
                    cos(rot),   0,          -sin(rot),  0,
                    0,          1,          0,          0,
                    sin(rot),   0,          cos(rot),   0,
                    0,          0,          0,          1   );
        
        //  Z]}gbNX
        rot = -camera->cz;
        setMatrix( RZmatrix,
                    cos(rot),   sin(rot),   0,          0,
                    -sin(rot),  cos(rot),   0,          0,
                    0,          0,          1,          0,
                    0,          0,          0,          1   );
        
        //  sړ}gbNX
        setMatrix( MVmatrix,
                    1,          0,          0,          0,
                    0,          1,          0,          0,
                    0,          0,          1,          0,
                    -camera->x, -camera->y, -camera->z, 1 );
        //  }gbNX̍
        calcMatrix(Mmatrix,MVmatrix);
        calcMatrix(Mmatrix,RXmatrix);
        calcMatrix(Mmatrix,RYmatrix);
        calcMatrix(Mmatrix,RZmatrix);
    }
    //  s̉ZB
    calcMatrixPoint(Mmatrix,Mpoint3D,point3D);
    
    //  ˉeϊsݒ肷B
    {
        double depth,ctan;
        double cnear,cfar,width,height;
        
        cnear = 0.1;
        cfar = 1000.0;
        ctan = tan(camera->genkaiangle*0.5);
        width = 1.0 / ctan;
        height = 1.0 / ctan;
        depth = cfar / (cfar - cnear);
        setMatrix( Pmatrix,
                        width,  0,    0,              0,
                        0,    height, 0,              0,
                        0,    0,      depth,          1,
                        0,    0,      -depth * cnear, 0 );
    }
    //  s̉ZB
    calcMatrixPoint(Pmatrix,Ppoint3D,Mpoint3D);
    
    //  ełȂ`FbN
    if( Ppoint3D[2] < 0 ) {
        return 0;
    }
    
    //  XN[WϊBAXyNg͂PFP
    *ox = camera->centery * Ppoint3D[0] / Ppoint3D[2] + camera->centerx;
    *oy = camera->centery * Ppoint3D[1] / Ppoint3D[2] + camera->centery;
    
    return 1;
}

void setdcamera(camera_t* lcamera,camera_t* rcamera,const camera_t* camera,double kyori) {
    double Mmatrix[4][4];//ړϊs
    double point3D[4];  //ϊOW
    double Lpoint3D[4];  //ϊWij 
    double Rpoint3D[4];  //ϊWiEj
    double RXmatrix[4][4];//X]s
    double RYmatrix[4][4];//Y]s
    double RZmatrix[4][4];//Z]s
    double MVmatrix[4][4];//sړs
    double rot; 
    //  RcWlݒ肷B
    point3D[0] = camera->x-kyori/2;
    point3D[1] = camera->y;
    point3D[2] = camera->z;
    point3D[3] = 1;
    
    //  Jr[ϊB
    
    //  Pʃ}gbNXݒ
    setMatrix( Mmatrix,
                1,          0,          0,          0,
                0,          1,          0,          0,
                0,          0,          1,          0,
                0,          0,          0,          1   );
    //  X]}gbNX
    rot = camera->cx;
    setMatrix( RXmatrix,
                1,          0,          0,          0,
                0,          cos(rot),   sin(rot),   0,
                0,          -sin(rot),  cos(rot),   0,
                0,          0,          0,          1   );
    //  Y]}gbNX
    rot = camera->cy;
    setMatrix( RYmatrix,
                cos(rot),   0,          -sin(rot),  0,
                0,          1,          0,          0,
                sin(rot),   0,          cos(rot),   0,
                0,          0,          0,          1   );
    
    //  Z]}gbNX
    rot = camera->cz;
    setMatrix( RZmatrix,
                cos(rot),   sin(rot),   0,          0,
                -sin(rot),  cos(rot),   0,          0,
                0,          0,          1,          0,
                0,          0,          0,          1   );
    
    //  sړ}gbNX
    setMatrix( MVmatrix,
                1,          0,          0,          0,
                0,          1,          0,          0,
                0,          0,          1,          0,
                camera->x,  camera->y,  camera->z,  1 );
    //  }gbNX̍
    calcMatrix(Mmatrix,RXmatrix);
    calcMatrix(Mmatrix,RYmatrix);
    calcMatrix(Mmatrix,RZmatrix);
    calcMatrix(Mmatrix,MVmatrix);
    
    //  s̉ZB
    calcMatrixPoint(Mmatrix,Lpoint3D,point3D);
    
    //  RcWlݒ肷B
    point3D[0] = camera->x+kyori/2;
    
    //  s̉ZB
    calcMatrixPoint(Mmatrix,Rpoint3D,point3D);
    
    //J̈ʒu̐ݒ
	lcamera->x=Lpoint3D[0];
	lcamera->y=Lpoint3D[1];
	lcamera->z=Lpoint3D[2];
	lcamera->cx=camera->cx;
	lcamera->cy=camera->cy;
	lcamera->cz=camera->cz;
	rcamera->x=Rpoint3D[0];
	rcamera->y=Rpoint3D[1];
	rcamera->z=Rpoint3D[2];
	rcamera->cx=camera->cx;
	rcamera->cy=camera->cy;
	rcamera->cz=camera->cz;
}

#ifdef ENABLE_INFO
int draw3dline(HDC hdc,double sx,double sy,double sz,
        double dx,double dy,double dz,const camera_t* camera,char *info) {
#else
int draw3dline(HDC hdc,double sx,double sy,double sz,
        double dx,double dy,double dz,const camera_t* camera) {
#endif
    double hx1,hy1,hx2,hy2;
    if(!henkan3dzahyou(&hx1,&hy1,sx,sy,sz,camera))return 0;
    if(!henkan3dzahyou(&hx2,&hy2,dx,dy,dz,camera))return 0;
    if(!MoveToEx(hdc,(int)hx1,(int)hy1,NULL))return 0;
    if(!LineTo(hdc,(int)hx2,(int)hy2))return 0;
#ifdef ENABLE_INFO
    if( info != NULL ) {
        wsprintf(info,"CW(%d,%d)-(%d,%d)",(int)hx1,(int)hy1,(int)hx2,(int)hy2);
    }
#endif
    return 1;
}
 
int draw3dtext(HDC hdc,double x,double y,double z,
        const char* text,const camera_t* camera) {
    double hx,hy;
    if(!henkan3dzahyou(&hx,&hy,x,y,z,camera))return 0;
    if(!TextOut(hdc,(int)hx,(int)hy,text,lstrlen(text)))return 0;
    return 1;
}

int drawd3dline(HDC hldc,HDC hrdc,double sx,double sy,double sz,
        double dx,double dy,double dz,const camera_t* lcamera,const camera_t* rcamera) {
	int result=1;
	result&=draw3dline(hldc,sx,sy,sz,dx,dy,dz,lcamera);
	result&=draw3dline(hrdc,sx,sy,sz,dx,dy,dz,rcamera);
	return result;
}
 
int drawd3dtext(HDC hldc,HDC hrdc,double x,double y,double z,
        const char* text,const camera_t* lcamera,const camera_t* rcamera) {
	int result=1;
	result&=draw3dtext(hldc,x,y,z,text,lcamera);
	result&=draw3dtext(hrdc,x,y,z,text,rcamera);
	return result;
}
