#include <windows.h>
#include <math.h>
#include "3d.h"

LPCSTR szWindowClass = "SAMPLE_CLASS";
LPCSTR szWindowTitle = "3DeXg";

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
						 WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	static HDC hldc,hrdc;
	static HBITMAP hlmembitmap,hloldbitmap;
	static HBITMAP hrmembitmap,hroldbitmap;
	HDC hwindc;
	static RECT clearrect;
	static camera_t camera;
	static camera_t lcamera,rcamera;
	static HPEN redpen,greenpen,bluepen;
	HPEN loldpen,roldpen;
	static drawnum;
	char info[1025];

	switch (message) {
		case WM_CREATE:
			hwindc=GetDC(hWnd);
			hldc=CreateCompatibleDC(hwindc);
			hlmembitmap=CreateCompatibleBitmap(hwindc,320,480);
			hloldbitmap=(HBITMAP)SelectObject(hldc,hlmembitmap);
			hrdc=CreateCompatibleDC(hwindc);
			hrmembitmap=CreateCompatibleBitmap(hwindc,320,480);
			hroldbitmap=(HBITMAP)SelectObject(hrdc,hrmembitmap);
			ReleaseDC(hWnd,hwindc);
			SetTimer(hWnd,0,20,NULL);
			camera.x=0;
			camera.y=0;
			camera.z=-300;
			camera.cx=0;
			camera.cy=0;
			camera.cz=0;
			lcamera.genkai=rcamera.genkai=camera.genkai=240;
			lcamera.genkaiangle=rcamera.genkaiangle=camera.genkaiangle=dec2rad(50);
			camera.centerx=320;
			camera.centery=240;
			lcamera.centerx=rcamera.centerx=160;
			lcamera.centery=rcamera.centery=240;
			clearrect.top=0;
			clearrect.left=0;
			clearrect.right=320;
			clearrect.bottom=480;
			redpen=CreatePen(PS_SOLID,1,RGB(255,0,0));
			greenpen=CreatePen(PS_SOLID,1,RGB(0,255,0));
			bluepen=CreatePen(PS_SOLID,1,RGB(0,0,255));
			drawnum=1;
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				default:
					return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hwindc = BeginPaint(hWnd, &ps);
			FillRect(hldc,&clearrect,GetStockObject(WHITE_BRUSH));
			FillRect(hrdc,&clearrect,GetStockObject(WHITE_BRUSH));
			setdcamera(&lcamera,&rcamera,&camera,30);
			
			SetBkMode(hldc,TRANSPARENT);
			SetBkMode(hrdc,TRANSPARENT);
			wsprintf(info,"W(%d,%d,%d)",(int)camera.x,(int)camera.y,(int)camera.z);
			TextOut(hldc,0,0,info,lstrlen(info));
			wsprintf(info,"x]*10000F%d",(int)(camera.cx*10000));
			TextOut(hldc,0,20,info,lstrlen(info));
			wsprintf(info,"y]*10000F%d",(int)(camera.cy*10000));
			TextOut(hldc,0,40,info,lstrlen(info));
			wsprintf(info,"z]*10000F%d",(int)(camera.cz*10000));
			TextOut(hldc,0,60,info,lstrlen(info));
			
			MoveToEx(hldc,155,235,NULL);
			LineTo(hldc,165,245);
			MoveToEx(hldc,155,245,NULL);
			LineTo(hldc,165,235);
			MoveToEx(hrdc,155,235,NULL);
			LineTo(hrdc,165,245);
			MoveToEx(hrdc,155,245,NULL);
			LineTo(hrdc,165,235);
			
			switch(drawnum) {
				case 1:/*̂̕`*/
					drawd3dline(hrdc,hldc,0,0,0,100,0,0,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,0,0,0,0,100,0,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,0,0,0,0,0,100,&lcamera,&rcamera);
					drawd3dtext(hrdc,hldc,100,0,0,"x",&lcamera,&rcamera);
					drawd3dtext(hrdc,hldc,0,100,0,"y",&lcamera,&rcamera);
					drawd3dtext(hrdc,hldc,0,0,100,"z",&lcamera,&rcamera);
					
					loldpen=SelectObject(hldc,redpen);
					roldpen=SelectObject(hrdc,redpen);
					drawd3dline(hrdc,hldc,0,0,200,0,0,300,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,0,0,300,100,0,300,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,100,0,300,100,0,200,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,100,0,200,0,0,200,&lcamera,&rcamera);
					
					SelectObject(hldc,greenpen);
					SelectObject(hrdc,greenpen);
					drawd3dline(hrdc,hldc,0,0,200,0,100,200,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,0,0,300,0,100,300,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,100,0,300,100,100,300,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,100,0,200,100,100,200,&lcamera,&rcamera);
					
					SelectObject(hldc,bluepen);
					SelectObject(hrdc,bluepen);
					drawd3dline(hrdc,hldc,0,100,200,0,100,300,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,0,100,300,100,100,300,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,100,100,300,100,100,200,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,100,100,200,0,100,200,&lcamera,&rcamera);
					
					/*y߂*/
					SelectObject(hldc,loldpen);
					SelectObject(hrdc,roldpen);
					break;
				case 2:case 3:case 4:case 5:case 6:/*3DOt̕`*/
					drawd3dline(hrdc,hldc,-150,0,0,150,0,0,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,0,-150,0,0,150,0,&lcamera,&rcamera);
					drawd3dline(hrdc,hldc,0,0,-150,0,0,150,&lcamera,&rcamera);
					drawd3dtext(hrdc,hldc,150,0,0,"x",&lcamera,&rcamera);
					drawd3dtext(hrdc,hldc,0,0,150,"y",&lcamera,&rcamera);
					drawd3dtext(hrdc,hldc,0,-150,0,"z",&lcamera,&rcamera);
					{
						double x,y,z;
						double nx,ny,nz;
						int dx,dy;
						loldpen=SelectObject(hldc,redpen);
						roldpen=SelectObject(hrdc,redpen);
						for(dy=-100;dy<=100;dy+=10) {
							for(dx=-100;dx<=100;dx+=10) {
								x=dx;y=dy;
								switch(drawnum) {
									case 2:z=x+y;break;
									case 3:z=sqrt(x*x+y*y);break;
									case 4:z=sqrt(abs(x*y));break;
									case 5:z=cos(x*y/20)*10;break;
									case 6:z=sqrt(abs(x*y))*(x*y>=0?1:-1);break;
								}
								if(dx<100) {
									nx=dx+10;ny=dy;
									switch(drawnum) {
										case 2:nz=nx+ny;break;
										case 3:nz=sqrt(nx*nx+ny*ny);break;
										case 4:nz=sqrt(abs(nx*ny));break;
										case 5:nz=cos(nx*ny/20)*10;break;
										case 6:nz=sqrt(abs(nx*ny))*(nx*ny>=0?1:-1);break;
									}
									drawd3dline(hrdc,hldc,x,-z,y,nx,-nz,ny,
										&lcamera,&rcamera);
								}
								if(dy<100) {
									nx=dx;ny=dy+10;
									switch(drawnum) {
										case 2:nz=nx+ny;break;
										case 3:nz=sqrt(nx*nx+ny*ny);break;
										case 4:nz=sqrt(abs(nx*ny));break;
										case 5:nz=cos(nx*ny/20)*10;break;
										case 6:nz=sqrt(abs(nx*ny))*(nx*ny>=0?1:-1);break;
									}
									drawd3dline(hrdc,hldc,x,-z,y,nx,-nz,ny,
										&lcamera,&rcamera);
								}
							}
						}
						SelectObject(hldc,loldpen);
						SelectObject(hrdc,roldpen);
					}
					break;
			}
			
			BitBlt(hwindc,0,0,320,480,hldc,0,0,SRCCOPY);
			BitBlt(hwindc,320,0,320,480,hrdc,0,0,SRCCOPY);
			MoveToEx(hwindc,320,0,NULL);
			LineTo(hwindc,320,480);
			EndPaint(hWnd, &ps);
			break;
		case WM_KEYDOWN:
			if(wParam>='0' && wParam<='9')drawnum=wParam-'0';
			break;
		case WM_TIMER:
			/*ړ*/
			if(GetAsyncKeyState(VK_SHIFT) & 0x8000) {
				if(GetAsyncKeyState(VK_CONTROL) & 0x8000) {
					if(GetAsyncKeyState(VK_UP) & 0x8000)
						camera.cz+=dec2rad(1);
					if(GetAsyncKeyState(VK_DOWN) & 0x8000)
						camera.cz-=dec2rad(1);
				} else {
					if(GetAsyncKeyState(VK_UP) & 0x8000)
						camera.cx+=dec2rad(1);
					if(GetAsyncKeyState(VK_DOWN) & 0x8000)
						camera.cx-=dec2rad(1);
				}
				if(GetAsyncKeyState(VK_LEFT) & 0x8000)
					camera.cy-=dec2rad(1);
				if(GetAsyncKeyState(VK_RIGHT) & 0x8000)
					camera.cy+=dec2rad(1);
			} else {
				if(GetAsyncKeyState(VK_CONTROL) & 0x8000) {
					if(GetAsyncKeyState(VK_UP) & 0x8000)
						camera.z+=5;
					if(GetAsyncKeyState(VK_DOWN) & 0x8000)
						camera.z-=5;
				} else {
				if(GetAsyncKeyState(VK_UP) & 0x8000)
					camera.y-=5;
				if(GetAsyncKeyState(VK_DOWN) & 0x8000)
					camera.y+=5;
				}	
				if(GetAsyncKeyState(VK_LEFT) & 0x8000)
					camera.x-=5;
				if(GetAsyncKeyState(VK_RIGHT) & 0x8000)
					camera.x+=5;
			}
			/*W̃Zbg*/
			if(GetAsyncKeyState(VK_F1) & 0x8000) {
				camera.x=0;
				camera.y=0;
				camera.z=-300;
				camera.cx=0;
				camera.cy=0;
				camera.cz=0;
				camera.centerx=320;
				camera.centery=240;
			}
			/*ĕ`*/
			InvalidateRect(hWnd,NULL,FALSE);
			break;
		case WM_DESTROY:
			KillTimer(hWnd,0);
			DeleteObject(redpen);
			DeleteObject(greenpen);
			DeleteObject(bluepen);
			SelectObject(hldc,hloldbitmap);
			DeleteObject(hlmembitmap);
			DeleteDC(hldc);
			SelectObject(hrdc,hroldbitmap);
			DeleteObject(hrmembitmap);
			DeleteDC(hrdc);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   	}

	return 0;
}

void wndresizebyclient(HWND hWnd,int x,int y) {
	RECT size;
	RECT wndsize;
	GetClientRect(hWnd,&size);
	GetWindowRect(hWnd,&wndsize);
	wndsize.right=wndsize.right-wndsize.left;
	wndsize.bottom=wndsize.bottom-wndsize.top;
	SetWindowPos(hWnd,NULL,0,0,x+wndsize.right-size.right,
		y+wndsize.bottom-size.bottom,SWP_NOMOVE | SWP_NOREPOSITION | SWP_NOZORDER);
}

int APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPSTR	 lpCmdLine,
					 int	   nCmdShow)
{
	MSG msg;
	WNDCLASSEX wcex;
	HWND hWnd;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style		  = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra	 = 0;
	wcex.cbWndExtra	 = 0;
	wcex.hInstance	  = hInstance;
	wcex.hIcon		  = LoadIcon(NULL,IDI_APPLICATION);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName   = NULL;
	wcex.lpszClassName  = szWindowClass;
	wcex.hIconSm		= NULL;

	RegisterClassEx(&wcex);

	hWnd = CreateWindow(szWindowClass,
		szWindowTitle, WS_OVERLAPPEDWINDOW & (~WS_THICKFRAME),
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
		NULL, NULL, hInstance, NULL);

	if (!hWnd)
		return FALSE;
	
	wndresizebyclient(hWnd,640,480);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}
